// dgbsv.cc
// ӹ

#include <stdio.h>

extern "C" {
  void dgbsv_ ( const int& N, const int& KL, const int& KU, const int& NRHS,
		double** AB, const int& LDAB, int* IPIV,
		double** B, const int& LDB, int& INFO );
};

//  3 Ӿι A  A x = b 򤯴ʰ״ؿ
// Input: A[3][N], b[N]  Output: x[N]
// A[1][N] гʬA[0][N] ˾гʬA[2][N] ˲гʬ
//
template <int N> int dgbsv3( double A[3][N], double x[N], double b[N] )
{
  int i, j, info;
  static int ipiv[N];
  static double AB[N][N];

  for( j=0; j<N; j++ ){
    for( i=0; i<3; i++ ){
      AB[j][1+i] = A[i][j];
    }
    x[j] = b[j];
  }

  dgbsv_( N, 1, 1, 1, (double**)AB, N, ipiv, (double**)x, N, info );

  return info;
}


//  5 Ӿι A  A x = b 򤯴ʰ״ؿ
// Input: A[3][N], b[N]  Output: x[N]
// A[2][N] гʬA[0,1][N] ˾гʬA[3,4][N] ˲гʬ
//
template <int N> int dgbsv5( double A[5][N], double x[N], double b[N] )
{
  int i, j, info;
  static int ipiv[N];
  static double AB[N][N];

  for( j=0; j<N; j++ ){
    for( i=0; i<5; i++ ){
      AB[j][2+i] = A[i][j];
    }
    x[j] = b[j];
  }

  dgbsv_( N, 2, 2, 1, (double**)AB, N, ipiv, (double**)x, N, info );

  return info;
}


int main(void)
{
  const int N = 8;
  int i, j, info;

  double A[5][N];
  double x[N], b[N];

  for( j=0; j<N; j++ ){
    A[0][j] = 1.0;
    A[1][j] = 1.0;
    A[2][j] = -2.0;
    A[3][j] = 1.0;
    A[4][j] = 1.0;
       b[j] = 5.0;
  }

  info = dgbsv5( A, x, b );

  printf("# info=%d.\n", info );

  printf("# Solution.\n");
  for( j=0; j<N; j++ ){
    printf("%+f\n", x[j] );
  }

  printf("# Error.\n");
  for( i=0; i<N; i++ ){
    double sum=0.0;
    for( j=i-2; j<=i+2; j++ ){
      if( j<0 || N<=j ) continue;
      sum += A[2+i-j][j]*x[j];
    }
    sum -= b[i];

    printf("%+f\n", sum );
  }

  return 0;
}
