// dstev.cc
// о3гѹθͭ

#include <stdio.h>

extern "C" {
  void dstev_ ( const char& JOBZ,
		const int& N,
		double* D, double* E, double** Z, 
		const int& LDZ, double* WORK,
		int& INFO, int JOBZlen );
};

// о3гѹ H θͭ H x = E x 򤯴ʰ״ؿ
// Input: H[2][N],  Output: U[N][N], E[N]
// H[0][N] гʬH[1][N] гʬ
// U^\dagger H U гѹȤʤ
//
template <int N> int dstev( double H[2][N], double U[N][N], double E[N] )
{
  int i, j, info;
  static double work[4*N];
  static double DL[N];

  for( j=0; j<N; j++ ){
     E[j] = H[0][j];
    DL[j] = H[1][j+1];
  }

  dstev_( 'V', N, E, DL, (double**)U, N, work, info, 1 );

  for( i=0; i<N; i++ ){
    for( j=i+1; j<N; j++ ){
      double temp;
      temp = U[i][j];
      U[i][j] = U[j][i];
      U[j][i] = temp;
    }
  }

  return info;
}

int main(void)
{
  const int N = 4;
  int i, j, info;

  double H[2][N], U[N][N], E[N];

  for( j=0; j<N; j++ ){
    H[0][j] = 0.0;
    H[1][j] = -1.0;
  }

  info = dstev( H, U, E );

  printf("# info=%d.\n", info );

  printf("# Eigen values.\n");
  for( j=0; j<N; j++ ){
    printf("%+f ", E[j] );
  }
  printf("\n");

  printf("# Eigen vectors.\n");
  for( i=0; i<N; i++ ){
    for( j=0; j<N; j++ ){
      printf("%+f ", U[i][j] );
    }
    printf("\n");
  }

  return 0;
}
