// dsygv.cc
// оιΰ̲ͭ

#include <stdio.h>

extern "C" {
  void dsygv_ ( const int& ITYPE, const char& JOBZ, const char& UPLO,
		const int& N,
		double** A, const int& LDA,
		double** B, const int& LDB,
		double* W, double* WORK, const int& LWORK,
		int& INFO, int JOBZlen, int UPLOlen );
};

// оι H,S ΰ̲ͭ H x = E S x 򤯴ʰ״ؿ
// Input: H[N][N], S[N][N],  Output: U[N][N], E[N]
// H[i][j<=i] S[i][j<=i] βѤȤʤ
// U^\dagger H U гѹU^\dagger S U ñ̹
//
template <int N> int dsygv( double H[N][N], double S[N][N], double U[N][N], double E[N] )
{
  int i, j, info;
  static double work[4*N];
  static double B[N][N];

  for( i=0; i<N; i++ ){
    for( j=0; j<N; j++ ){
      U[i][j] = H[j][i];
      B[i][j] = S[j][i];
    }
  }

  dsygv_( 1, 'V', 'L', N, (double**)U, N, (double**)B, N, E, work, 4*N, info, 1, 1 );

  for( i=0; i<N; i++ ){
    for( j=i+1; j<N; j++ ){
      double temp;
      temp = U[i][j];
      U[i][j] = U[j][i];
      U[j][i] = temp;
    }
  }

  return info;
}

int main(void)
{
  const int N = 4;
  int i, j, info;
  double H[N][N], S[N][N], U[N][N], E[N];

  for( i=0; i<N; i++ ){
    for( j=0; j<N; j++ ){
      if( i == j+1 || i == j-1 ){
	H[i][j] = -1.0;
      }else{
	H[i][j] = 0.0;
      }
      if( i == j ){
	S[i][j] = 1.0;
      }else if( i == j+1 || i == j-1 ){
	S[i][j] = 0.5;
      }else{
	S[i][j] = 0.0;
      }
    }
  }

  info = dsygv( H, S, U, E );

  printf("# info=%d.\n", info );

  printf("# Eigen values.\n");
  for( j=0; j<N; j++ ){
    printf("%+f ", E[j] );
  }
  printf("\n");

  printf("# Eigen vectors.\n");
  for( i=0; i<N; i++ ){
    for( j=0; j<N; j++ ){
      printf("%+f ", U[i][j] );
    }
    printf("\n");
  }

  return 0;
}
