// zgtsv.cc
// ʣ3гѹ

#include <stdio.h>
#include <complex>
typedef std::complex<double> Complex;

extern "C" {
  void zgtsv_ ( const int& N, const int& NRHS,
		Complex* DL, Complex* D, Complex* DU,
		Complex** B, const int& LDB, int& INFO );
};

// ʣ 3гѹ A  A x = b 򤯴ʰ״ؿ
// Input: A[3][N], b[N]  Output: x[N]
// A[1][N] гʬA[0][N] ˾гʬA[2][N] ˲гʬ
//
template <int N> int zgtsv( Complex A[3][N], Complex x[N], Complex b[N] )
{
  int j, info;
  static Complex DL[N], D[N], DU[N];

  for( j=0; j<N; j++ ){
    DU[j] = A[0][j+1];
     D[j] = A[1][j];
    DL[j] = A[2][j];

    x[j] = b[j];
  }

  zgtsv_( N, 1, DL, D, DU, (Complex**)x, N, info );

  return info;
}


int main(void)
{
  const int N = 4;
  int i, j, info;

  Complex A[3][N];
  Complex x[N], b[N];

  for( j=0; j<N; j++ ){
    A[0][j] = 1.0;
    A[1][j] = -2.0;
    A[2][j] = 1.0;
       b[j] = 5.0;
  }

  info = zgtsv( A, x, b );

  printf("# info=%d.\n", info );

  printf("# Solution.\n");
  for( j=0; j<N; j++ ){
    printf("%+f%+f\n", real(x[j]), imag(x[j]) );
  }

  printf("# Error.\n");
  for( i=0; i<N; i++ ){
    Complex sum=0.0;
    for( j=i-1; j<=i+1; j++ ){
      if( j<0 || N<=j ) continue;
      sum += A[1+i-j][j]*x[j];
    }
    sum -= b[i];

    printf("%+f%+f\n", real(sum), imag(sum) );
  }

  return 0;
}
