// zhtev.cc
// ʣǥߡ3гѹθͭ

#include <stdio.h>
#include <complex>
typedef std::complex<double> Complex;

extern "C" {
  void zhbev_ ( const char& JOBZ, const char& UPLO,
		const int& N, const int& KD,
		Complex** AB, const int& LDAB,
		double* W,
		Complex** Z, const int& LDZ,
		Complex* WORK, double* RWORK,
		int& INFO, int JOBZlen, int UPLOlen );
};

// ʣǥߡ3гѹ H θͭ H x = E x 򤯴ʰ״ؿ
// Input: H[2][N],  Output: U[N][N], E[N]
// H[0][N] гʬH[1][N] гʬ
// U^\dagger H U гѹȤʤ
//
template <int N> int zhtev( Complex H[2][N], Complex U[N][N], double E[N] )
{
  int i, j, info;
  static Complex cwork[4*N];
  static double  rwork[4*N];
  static Complex AB[N][N];

  for( j=0; j<N; j++ ){
    for( i=0; i<2; i++ ){
      AB[j][i] = H[i][j];
    }
  }

  zhbev_( 'V', 'L', N, 1, (Complex**)AB, N, E, (Complex**)U, N, cwork, rwork, info, 1, 1 );

  for( i=0; i<N; i++ ){
    for( j=i+1; j<N; j++ ){
      Complex temp;
      temp = U[i][j];
      U[i][j] = U[j][i];
      U[j][i] = temp;
    }
  }

  return info;
}

int main(void)
{
  const int N = 4;
  int i, j, info;

  Complex H[2][N], U[N][N];
  double E[N];

  for( j=0; j<N; j++ ){
    H[0][j] = 0.0;
    H[1][j] = -1.0;
  }

  info = zhtev( H, U, E );

  printf("# info=%d.\n", info );

  printf("# Eigen values.\n");
  for( j=0; j<N; j++ ){
    printf("%+f ", E[j] );
  }
  printf("\n");

  printf("# Eigen vectors.\n");
  for( i=0; i<N; i++ ){
    for( j=0; j<N; j++ ){
      printf("%+f%+f ", real(U[i][j]), imag(U[i][j]) );
    }
    printf("\n");
  }

  return 0;
}
